﻿var chk = false;
var TMan = new N6LTimerMan();  //timer manager//タイマーマネージャー
var x3domRuntime;

var fr = 1000;
var A = new N6LMatrix(4).UnitMat();  //mat view//view回転行列
var A2 = new N6LMatrix(4).UnitMat();  //mat view//view回転行列

function chgrotVec(){
  var elm = document.getElementById('rotin');
  var ro = String(elm.value);
  elm = document.getElementById('rot');
  elm.value = ro;
  elm = document.getElementById('trnsin');
  var tr = String(elm.value);
  elm = document.getElementById('trns');
  elm.value = tr
  var rot = new N6LVector().Parse(ro);
  var trs = new N6LVector().Parse(tr);
  var radioList = document.getElementsByName("INV");
  var dt = [];
  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }
  rot = A.Vector();
  elm = document.getElementById('viewp001');
  elm.setAttribute('orientation', rot.ToX3DOM().toString());
  var ea = A.EulerAngle(1,2,3);
  elm = document.getElementById('rotEA');
  var str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;
  var qt = A.Quaternion();
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = 'true,4&#13;true,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '&#13;true,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.value = str;

  if(radioList[0].checked) {
    A = A.InverseMat(dt);
  }
}

function chgrotEA(){
  var elm = document.getElementById('rotEAin');
  var roEA = String(elm.value);
  elm = document.getElementById('rotEA');
  elm.value = roEA;
  elm = document.getElementById('trnsin');
  var tr = String(elm.value);
  elm = document.getElementById('trns');
  elm.value = tr
  var trs = new N6LVector().Parse(tr);
  var tk = roEA.split(',');
  var ea = new N6LVector([1,Number(tk[0])*(Math.PI/180.0),Number(tk[1])*(Math.PI/180.0),Number(tk[2])*(Math.PI/180.0)],true);
  var ax = new N6LVector(4,true).UnitVec(1);
  var ay = new N6LVector(4,true).UnitVec(2);
  var az = new N6LVector(4,true).UnitVec(3);
  A = A.UnitMat().RotAxis(ax,ea.x[1]);
  ay = A.GetRow(2);
  A = A.RotAxis(ay,ea.x[2]);
  az = A.GetRow(3);
  A = A.RotAxis(az,ea.x[3]);
  var radioList = document.getElementsByName("INV");
  var rot = A.Vector();
  var dt = [];
  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }
  rot = A.Vector();
  elm = document.getElementById('viewp001');
  elm.setAttribute('orientation', rot.ToX3DOM().toString());
  elm = document.getElementById('rot');
  var str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;
  var qt = A.Quaternion();
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = 'true,4&#13;true,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '&#13;true,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.value = str;
  if(radioList[0].checked) {
    A = A.InverseMat(dt);
  }
}

function chgrotQT(){
  var elm = document.getElementById('rotQTin');
  var ro = String(elm.value);
  elm = document.getElementById('rotQT');
  elm.value = ro;
  elm = document.getElementById('trnsin');
  var tr = String(elm.value);
  elm = document.getElementById('trns');
  elm.value = tr
  var trs = new N6LVector().Parse(tr);
  var qt = new N6LQuaternion().Parse(ro);
  var dt = [];
  A = qt.Matrix();
  var rot = A.Vector();
  var radioList = document.getElementsByName("INV");
  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }
  rot = A.Vector();
  elm = document.getElementById('viewp001');
  elm.setAttribute('orientation', rot.ToX3DOM().toString());
  elm = document.getElementById('rot');
  var str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;
  var ea = A.EulerAngle(1,2,3);
  elm = document.getElementById('rotEA');
  str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = 'true,4&#13;true,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '&#13;true,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.value = str;

  if(radioList[0].checked) {
    A = A.InverseMat(dt);
  }
}

function chgrotOC(){
  var elm = document.getElementById('rotOCin');
  var ro = String(elm.value);
  elm = document.getElementById('rotOC');
  elm.value = ro;
  var oc = new N6LVector().Parse(ro);
  A = oc.PosVecMatrix();

  var radioList = document.getElementsByName("INV");
  var dt = [];
  var rot = A.Vector();
  var trs = A.Pos();
  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }
  rot = A.Vector();
  elm = document.getElementById('viewp001');
  elm.setAttribute('orientation', rot.ToX3DOM().toString());
  elm = document.getElementById('rot');
  var str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('trns');
  str = 'true,4,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  elm.value = str;
  var ea = A.EulerAngle(1,2,3);
  elm = document.getElementById('rotEA');
  var str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;
  var qt = A.Quaternion();
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = 'true,4&#13;true,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '&#13;true,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.value = str;

  if(radioList[0].checked) {
    A = A.InverseMat(dt);
  }
}

function chgrotMT(){
  var elm = document.getElementById('rotMTin');
  var ro = String(elm.value);
  elm = document.getElementById('rotMT');
  elm.value = ro;
  ro = ro.replace(/\n/g, " ");
  A = new N6LMatrix().Parse(ro);
  var radioList = document.getElementsByName("INV");
  var dt = [];
  var rot = A.Vector();
  var trs = A.Pos();
  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }
  rot = A.Vector();
  elm = document.getElementById('viewp001');
  elm.setAttribute('orientation', rot.ToX3DOM().toString());
  elm = document.getElementById('rot');
  var str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('trns');
  str = 'true,4,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  elm.value = str;
  var ea = A.EulerAngle(1,2,3);
  elm = document.getElementById('rotEA');
  var str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;
  var qt = A.Quaternion();
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = 'true,4&#13;true,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '&#13;true,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '&#13;true,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.value = str;

  if(radioList[0].checked) {
    A = A.InverseMat(dt);
  }
}


function apply(){
  var elm = document.getElementById('trns');
  var str = String(elm.value);
  elm = document.getElementById('trns2');
  elm.value = str;
  elm = document.getElementById('rot');
  str = String(elm.value);
  elm = document.getElementById('rot2');
  elm.value = str;
  elm = document.getElementById('rotEA');
  str = String(elm.value);
  elm = document.getElementById('rot2EA');
  elm.value = str;
  elm = document.getElementById('rotQT');
  str = String(elm.value);
  elm = document.getElementById('rot2QT');
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = String(elm.value);
  elm = document.getElementById('rot2OC');
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = String(elm.value);
  elm = document.getElementById('rot2MT');
  elm.value = str;
  A2 = new N6LMatrix(A);
}

function copy(){
  var elm = document.getElementById('trns');
  var str = String(elm.value);
  elm = document.getElementById('trnsin');
  elm.value = str;
  elm = document.getElementById('rot');
  str = String(elm.value);
  elm = document.getElementById('rotin');
  elm.value = str;
  elm = document.getElementById('rotEA');
  str = String(elm.value);
  elm = document.getElementById('rotEAin');
  elm.value = str;
  elm = document.getElementById('rotQT');
  str = String(elm.value);
  elm = document.getElementById('rotQTin');
  elm.value = str;
  elm = document.getElementById('rotOC');
  str = String(elm.value);
  elm = document.getElementById('rotOCin');
  elm.value = str;
  elm = document.getElementById('rotMT');
  str = String(elm.value);
  elm = document.getElementById('rotMTin');
  elm.value = str;
}

jQuery(document).ready(function(){
  TMan.add();
  TMan.timer[0].setalerm(function() { GLoop(0); }, 50);  //set main loop//メインループセット
});

var be = true;
function input(){
  var str;
  if(be) str = 'rgb(255,255,255)';
  else str = 'rgb(136,136,136)';
  var elm = document.getElementById('trnsin');
  elm.style.backgroundColor = str;
  elm = document.getElementById('rotin');
  elm.style.backgroundColor = str;
  elm = document.getElementById('rotEAin');
  elm.style.backgroundColor = str;
  elm = document.getElementById('rotQTin');
  elm.style.backgroundColor = str;
  elm = document.getElementById('rotOCin');
  elm.style.backgroundColor = str;
  elm = document.getElementById('rotMTin');
  elm.style.backgroundColor = str;
  if(be) be = false;
  else be = true;
  KeyB.setenable(be);
}


var FF=true;

//main loop//メインループ
function GLoop(id){
  if(x3domRuntime == undefined) {
    x3domRuntime = document.getElementById('x3dabs').runtime; 
    TMan.timer[id].setalerm(function() { GLoop(id); }, 50);  //reset main loop//メインループ再セット
    return;
  }

  var elm = document.getElementById('viewp001');

  var SWM = x3domRuntime.viewMatrix().inverse(); //ワールド回転行列取得
  A = new N6LMatrix().FromX3DOM(SWM);

  var radioList = document.getElementsByName("INV");
  var dt = [];
  var rot = A.Vector();
  elm = document.getElementById('trns');
  var tr = String(elm.value);
  var trs = new N6LVector().Parse(tr);
 

  if(radioList[0].checked) {
    A = rot.Matrix().TranslatedMat(trs);
    A = A.InverseMat(dt);
  }
  else {
    A = rot.Matrix().TranslatedMat(trs);
  }

  var A3 = A.Mul(A2);



  var ea = A3.EulerAngle(1,2,3);
  var elm = document.getElementById('rot3EA');
  var str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;

  var trs = A3.Pos();
  elm = document.getElementById('trns3');
  str = 'true,4,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  elm.value = str;

  rot = A3.Vector();
  elm = document.getElementById('rot3');
  str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;

  var qt = A3.Quaternion();
  elm = document.getElementById('rot3QT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;

  elm = document.getElementById('rot3OC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;

  elm = document.getElementById('rot3MT');
  str = 'true,4\ntrue,4,'+String(Math.floor(A3.x[0].x[0]*fr)/fr)+','+String(Math.floor(A3.x[0].x[1]*fr)/fr)+','+String(Math.floor(A3.x[0].x[2]*fr)/fr)+','+String(Math.floor(A3.x[0].x[3]*fr)/fr) +
        '\ntrue,4,'+String(Math.floor(A3.x[1].x[0]*fr)/fr)+','+String(Math.floor(A3.x[1].x[1]*fr)/fr)+','+String(Math.floor(A3.x[1].x[2]*fr)/fr)+','+String(Math.floor(A3.x[1].x[3]*fr)/fr) +  
        '\ntrue,4,'+String(Math.floor(A3.x[2].x[0]*fr)/fr)+','+String(Math.floor(A3.x[2].x[1]*fr)/fr)+','+String(Math.floor(A3.x[2].x[2]*fr)/fr)+','+String(Math.floor(A3.x[2].x[3]*fr)/fr) +  
        '\ntrue,4,'+String(Math.floor(A3.x[3].x[0]*fr)/fr)+','+String(Math.floor(A3.x[3].x[1]*fr)/fr)+','+String(Math.floor(A3.x[3].x[2]*fr)/fr)+','+String(Math.floor(A3.x[3].x[3]*fr)/fr);
  elm.innerText = str;
  elm.value = str;

  ea = A.EulerAngle(1,2,3);
  elm = document.getElementById('rotEA');
  str = String(Math.floor(ea.x[1]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[2]*(180.0/Math.PI)*fr)/fr)+','+String(Math.floor(ea.x[3]*(180.0/Math.PI)*fr)/fr);
  elm.value = str;

  trs = A.Pos();
  elm = document.getElementById('trns');
  str = 'true,4,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  elm.value = str;

  rot = A.Vector();
  elm = document.getElementById('rot');
  str = 'true,4,'+String(Math.floor(rot.x[0]*fr)/fr)+','+String(Math.floor(rot.x[1]*fr)/fr)+','+String(Math.floor(rot.x[2]*fr)/fr)+','+String(Math.floor(rot.x[3]*fr)/fr);
  elm.value = str;

  qt = A.Quaternion();
  elm = document.getElementById('rotQT');
  str = 'true,4,'+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;

  elm = document.getElementById('rotOC');
  str = 'true,8,'+String(Math.floor(trs.x[0]*fr)/fr)+','+String(Math.floor(trs.x[1]*fr)/fr)+','+String(Math.floor(trs.x[2]*fr)/fr)+','+String(Math.floor(trs.x[3]*fr)/fr);
  str += ','+String(Math.floor(qt.q.x[0]*fr)/fr)+','+String(Math.floor(qt.q.x[1]*fr)/fr)+','+String(Math.floor(qt.q.x[2]*fr)/fr)+','+String(Math.floor(qt.q.x[3]*fr)/fr);
  elm.value = str;

  elm = document.getElementById('rotMT');
  str = 'true,4\ntrue,4,'+String(Math.floor(A.x[0].x[0]*fr)/fr)+','+String(Math.floor(A.x[0].x[1]*fr)/fr)+','+String(Math.floor(A.x[0].x[2]*fr)/fr)+','+String(Math.floor(A.x[0].x[3]*fr)/fr) +
        '\ntrue,4,'+String(Math.floor(A.x[1].x[0]*fr)/fr)+','+String(Math.floor(A.x[1].x[1]*fr)/fr)+','+String(Math.floor(A.x[1].x[2]*fr)/fr)+','+String(Math.floor(A.x[1].x[3]*fr)/fr) +  
        '\ntrue,4,'+String(Math.floor(A.x[2].x[0]*fr)/fr)+','+String(Math.floor(A.x[2].x[1]*fr)/fr)+','+String(Math.floor(A.x[2].x[2]*fr)/fr)+','+String(Math.floor(A.x[2].x[3]*fr)/fr) +  
        '\ntrue,4,'+String(Math.floor(A.x[3].x[0]*fr)/fr)+','+String(Math.floor(A.x[3].x[1]*fr)/fr)+','+String(Math.floor(A.x[3].x[2]*fr)/fr)+','+String(Math.floor(A.x[3].x[3]*fr)/fr);
  elm.innerText = str;
  elm.value = str;


  elm = document.getElementById('rotOC');
  var stroc = String(elm.value);
  var oc = new N6LVector().Parse(stroc);
  elm = document.getElementById('rot2OC');
  var stroc2 = String(elm.value);
  var oc2 = new N6LVector().Parse(stroc2);
  var oc3=oc.PosVecMul(oc2);
  elm = document.getElementById('rot3COC');
  str = 'true,8,'+String(Math.floor(oc3.x[0]*fr)/fr)+','+String(Math.floor(oc3.x[1]*fr)/fr)+','+String(Math.floor(oc3.x[2]*fr)/fr)+','+String(Math.floor(oc3.x[3]*fr)/fr);
  str += ','+String(Math.floor(oc3.x[4]*fr)/fr)+','+String(Math.floor(oc3.x[5]*fr)/fr)+','+String(Math.floor(oc3.x[6]*fr)/fr)+','+String(Math.floor(oc3.x[7]*fr)/fr);
  elm.value = str;


  if(radioList[0].checked) {
    ;
  }
  else {
    A = A.InverseMat(dt);
  }


  if(FF){
    FF=false;
    apply();
  }


  var p = A3.InverseMat(dt).Pos();
  var o = A3.InverseMat(dt).Vector();

  elm = document.getElementById('oniT0');
  elm.setAttribute('translation', p.ToX3DOM(true).toString());
  elm = document.getElementById('oniR0');
  elm.setAttribute('rotation', o.ToX3DOM().toString());
  elm.setAttribute('render', 'true');

  TMan.timer[id].setalerm(function() { GLoop(id); }, 50);  //reset main loop//メインループ再セット
}

//キー入力
function chkKeyBoard(){
  var b = false;
  var p = 0.0;
  var y = 0.0;
  var r = 0.0;
  var ad = 0.05;
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N2'))]) {//N2Key
    b = true;
    p -= ad;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N8'))]) {//N8Key
    b = true;
    p += ad;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N4'))]) {//N4Key
    b = true;
    y -= ad;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N6'))]) {//N6Key
    b = true;
    y += ad;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N1'))]) {//N1Key
    b = true;
    r -= ad;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N3'))]) {//N3Key
    b = true;
    r += ad;
  }
  if(b) {
    var dt = [];
    var rot = A.Vector();
    A = rot.Matrix();
    A = A.InverseMat(dt);
    var wpyr = new N6LVector([1, p, y, r], true);
    var outmat = [];
    var outv = [];
    A = A.MoveMat(outmat, outv, new N6LVector(4, true).ZeroVec(), wpyr, 0, 0, 0, 0); //目的の関数
    rot = A.Vector();
    var elm = document.getElementById('viewp001');
    elm.setAttribute('orientation', rot.ToX3DOM().toString());
    A = A.InverseMat(dt);
  }
};

